<?php

	/**
	 * Modul "Bestellupload"
	 */
	class wpsg_mod_orderupload extends wpsg_mod_basic 
	{
		
		var $id = 1600;		
		var $lizenz = 1;
		var $version = "9.9.9";
		var $hilfeURL = 'http://wpshopgermany.de/?p=5729960';
		
		const MODE_ORDER = 1;
		const MODE_PRODUCT = 2;
		
		/**
		 * Costructor
		 */
		public function __construct()
		{
			
			parent::__construct();
			
			$this->name = __('Bestellupload', 'wpsg');
			$this->group = __('Bestellung', 'wpsg');
			$this->desc = __('Erlaubt das Hochladen von Dateien zu Bestellungen.', 'wpsg');
						
		} // public function __construct()
		
		public function install()
		{
			
			$this->shop->checkDefault('wpsg_mod_orderupload_filename', '%order_onr%_%filename%');
			$this->shop->checkDefault('wpsg_mod_orderupload_allowedext', 'jpg,jpeg');
			$this->shop->checkDefault('wpsg_mod_orderupload_multifiles', '0');
			$this->shop->checkDefault('wpsg_mod_orderupload_optional', '0');

            require_once(WPSG_PATH_WP.'/wp-admin/includes/upgrade.php');

            /**
             * Produkttabelle erweitern
             */
            $sql = "CREATE TABLE ".WPSG_TBL_PRODUCTS." (
		   		wpsg_mod_orderupload_set INT(11) NOT NULL,
		   		wpsg_mod_orderupload_mandatory INT(1) NOT NULL
		   	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";

            dbDelta($sql);
            
		} // public function install()
		
		public function settings_edit()
		{
			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_orderupload/settings_edit.phtml');
			
		} // public function settings_edit()
		
		public function settings_save()
		{

		    $this->shop->update_option('wpsg_mod_orderupload_filename', $_REQUEST['wpsg_mod_orderupload_filename'], false, false, WPSG_SANITIZE_TEXTFIELD);
		    $this->shop->update_option('wpsg_mod_orderupload_allowedext', $_REQUEST['wpsg_mod_orderupload_allowedext'], false, false, WPSG_SANITIZE_TEXTFIELD);
		    $this->shop->update_option('wpsg_mod_orderupload_multifiles', $_REQUEST['wpsg_mod_orderupload_multifiles'], false, false, WPSG_SANITIZE_CHECKBOX);
		    $this->shop->update_option('wpsg_mod_orderupload_optional', $_REQUEST['wpsg_mod_orderupload_optional'],false, false, WPSG_SANITIZE_CHECKBOX);
			$this->shop->update_option('wpsg_mod_orderupload_zip', $_REQUEST['wpsg_mod_orderupload_zip'], false, false, WPSG_SANITIZE_CHECKBOX);
			$this->shop->update_option('wpsg_mod_orderupload_maxweight', $_REQUEST['wpsg_mod_orderupload_maxweight'], false, false, WPSG_SANITIZE_TEXTFIELD);
			$this->shop->update_option('wpsg_mod_orderupload_mail', $_REQUEST['wpsg_mod_orderupload_mail'], false, false, WPSG_SANITIZE_CHECKBOX);
			$this->shop->update_option('wpsg_mod_orderupload_maxweight_text', $_REQUEST['wpsg_mod_orderupload_maxweight_text'], false, false, WPSG_SANITIZE_TEXTFIELD);
			$this->shop->update_option('wpsg_mod_orderupload__mode', $_REQUEST['wpsg_mod_orderupload__mode'], false, false, WPSG_SANITIZE_INT);
			
		} // public function settings_save()
		
		public function checkout_inner_prebutton(&$checkout_view) { 
			
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_orderupload/checkout_inner_prebutton.phtml');
			
		} // public function checkout_inner_prebutton(&$checkout_view)
		
		public function checkCheckout(&$state, &$error, &$arCheckout)  
		{
			
			if ($state == '1')
			{
			 
				if (
					$this->shop->get_option('wpsg_mod_orderupload_optional') != '1' && 
					sizeof($_SESSION['wpsg']['wpsg_mod_orderupload']) <= 0 &&
					(!isset($_FILES['wpsg_mod_orderupload_file']) || !file_exists($_FILES['wpsg_mod_orderupload_file']['tmp_name']))
					)
				{
					
					if (isset($_REQUEST['wpsg_mod_kundenverwaltung_register'])) return;
					if (isset($_REQUEST['wpsg_mod_kundenverwaltung_save'])) return;
					
					// Noch keine Datei hochgeladen und es ist Pflicht !										
					$this->shop->addFrontendError(__('Bitte eine Datei zum Upload wählen.', 'wpsg'));
					$error = true; return;
					
				}
				
				if (isset($_FILES['wpsg_mod_orderupload_file']) && file_exists($_FILES['wpsg_mod_orderupload_file']['tmp_name']))
				{
					
					$ending = strtolower(preg_replace('/(.*)\./', '', $_FILES['wpsg_mod_orderupload_file']['name']));
					
					if (!in_array($ending, (array)explode(',', strtolower($this->shop->get_option('wpsg_mod_orderupload_allowedext')))))
					{
						
						$this->shop->addFrontendError(__('Bitte eine gültige Dateiendung verwenden.', 'wpsg'));
						$error = true; return;
						
					}
					else
					{
						
						// Upload durchführen
						$tmp = time().'-'.rand(1, 10000).'.'.$ending;
						
						move_uploaded_file($_FILES['wpsg_mod_orderupload_file']['tmp_name'], $this->getTmpFilePath().'/'.$tmp); 
						
						if (!is_array($_SESSION['wpsg']['wpsg_mod_orderupload'])) $_SESSION['wpsg']['wpsg_mod_orderupload'] = array();
						else if (wpsg_isSizedArray($_SESSION['wpsg']['wpsg_mod_orderupload']) && $this->shop->get_option('wpsg_mod_orderupload_multifiles') != '1')
						{
							
							// Cache sauber halten
							foreach ($_SESSION['wpsg']['wpsg_mod_orderupload'] as $ou)
							{
																
								unlink($ou[3]);
								
							}
							
							$_SESSION['wpsg']['wpsg_mod_orderupload'] = array();
						 							
						}
						
						$_SESSION['wpsg']['wpsg_mod_orderupload'][] = wpsg_xss(array(
							$_FILES['wpsg_mod_orderupload_file']['name'],
							$tmp,
							$this->getTmpFilePath(true).'/'.$tmp,
							$this->getTmpFilePath().'/'.$tmp			
						));
						
						$this->shop->addFrontendMessage(__('Datei wurde erfolgreich hochgeladen.', 'wpsg'));
						
						if ($this->shop->get_option('wpsg_mod_orderupload_multifiles') == '1')
						{
							
							$error = true;
							
						}
						
					}
					
				}
				
			}
			
		} // public function checkCheckout(&$state, &$error, &$arCheckout)
         
		public function checkBasket(&$noError) {
			
			$sum = 0;
            
			if (wpsg_isSizedArray($_SESSION['wpsg']['wpsg_mod_orderupload'])) {
			    
				foreach ($_SESSION['wpsg']['wpsg_mod_orderupload'] as $k => $ou) $sum += filesize($ou[3]);
                
			}
			
			$sum = $sum / (1024 * 1000);
			$sum = $this->shop->get_option('wpsg_mod_orderupload_maxweight') - $sum;
			
            $text = __($this->shop->get_option('wpsg_mod_orderupload_maxweight_text'), 'wpsg');
            
            if ($sum <= 0 & wpsg_isSizedString($text)) { $this->shop->addFrontendError($text); $noError = false; }
			
			$this->shop->view['wpsg_mod_orderupload']['uploadsum'] = round($sum, 2);
			$this->shop->view['wpsg_mod_orderupload']['maxweight'] = $this->shop->get_option('wpsg_mod_orderupload_maxweight');
			
            // Uploads bei den Produkten checken
            $arBasket = $this->shop->cache->getShopBasketArray();
            
            foreach ($arBasket['produkte'] as $product_index => $product_basket_data) {
                
                $oProduct = wpsg_product::getInstance($product_basket_data['product_id']);
                
                $mandatory = $oProduct->wpsg_mod_orderupload_mandatory;
                
                if (wpsg_isSizedInt($mandatory)) {

                    $set = $oProduct->wpsg_mod_orderupload_set;
                    $arFilesUploaded = $this->getProductUploads($arBasket['oOrder']->id, $product_basket_data['product_index'], $product_basket_data['product_id']);
                    
                    if (sizeof($arFilesUploaded) < $set) {
                        
                        $this->shop->addFrontendError(
                            wpsg_translate(__('Sie müssen bei Produkt "#1#" mindestens #2# Datei(en) angeben.', 'wpsg'), $oProduct->getProductName(), $set)
                        );
                        
                        $noError = false;
                        
                    }
                    
                }
                
            }
                        
		}
		
		public function wp_loaded() 
		{ 
			
			if ($_REQUEST['wpsg_plugin'] == 'wpsg_mod_orderupload' && $_REQUEST['wpsg_action'] == 'remove')
			{
				
				unlink($_SESSION['wpsg']['wpsg_mod_orderupload'][$_REQUEST['file_index']][3]);
				unset($_SESSION['wpsg']['wpsg_mod_orderupload'][$_REQUEST['file_index']]);
				
				$this->shop->addFrontendMessage(__('Dokument wurde aus der Bestellung entfernt.', 'wpsg'));
				
				$this->shop->redirect($this->shop->getURL(wpsg_ShopController::URL_CHECKOUT));
				
			}
			
		} // public function wp_loaded()
 
		public function order_ajax() { 
			
			if (isset($_REQUEST['wpsg_mod_orderupload_download'])) {

				$_REQUEST['edit_id'] = wpsg_sinput("key", $_REQUEST['edit_id']);
				$_REQUEST['product_index'] = wpsg_xss($_REQUEST['product_index']);
				$_REQUEST['wpsg_mod_orderupload_download'] = wpsg_xss($_REQUEST['wpsg_mod_orderupload_download']);

                if (isset($_REQUEST['product_index'])) {
                    
                    $path = $this->getProductStoragePath($_REQUEST['edit_id'], $_REQUEST['product_index']);
                    $file = $path.$_REQUEST['wpsg_mod_orderupload_download'];
                                        
                } else {
                
				    $file = $this->getSavePath($_REQUEST['edit_id']).'/'.rawurldecode($_REQUEST['wpsg_mod_orderupload_download']);
                                        
                }
                
                if (!file_exists($file)) throw new \Exception(__('Datei existiert nicht mehr auf dem Server.', 'wpsg')); 
                else {

                    header('Content-Disposition: attachment; filename="'.rawurldecode($_REQUEST['wpsg_mod_orderupload_download']).'"');
                    header('Content-type: application/download');
                    header('Content-Disposition: inline; filename="'.rawurldecode($_REQUEST['wpsg_mod_orderupload_download']).'"');
                    header('Expires: 0');
                    header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                    header('Pragma: public');
                    
                    echo file_get_contents($file);
                    exit;
                    
                }
				
			}
			
		} // public function order_ajax() 
		
		public function basket_save_done(&$o_id, &$k_id, &$oBasket) {
			
			if (wpsg_isSizedArray($_SESSION['wpsg']['wpsg_mod_orderupload'])) {
				
				foreach ($_SESSION['wpsg']['wpsg_mod_orderupload'] as $k => $ou) {
					 
					$path_target = $this->getSavePath($o_id);
					
					copy(
						$ou[3], 
						$path_target.'/'.$this->getNewName($ou[0], $o_id)
					);
					
					// Temporären Ordner säubern
					unlink($ou[3]);
					
					//unset($_SESSION['wpsg']['wpsg_mod_orderupload'][$k]);
					
				}
				
			}
			
		} // public function basket_save_done($o_id, $k_id)
		
		public function order_view_sidebar(&$order_id) {

			$path = $this->getSavePath($order_id);

			$arFiles = scandir($path);

			foreach ($arFiles as $k => $v) { if (in_array($v, array('.', '..', '.htaccess', '.htpasswd')) || is_dir($path.$v)) {  unset($arFiles[$k]); } }
			
			if (sizeof($arFiles) <= 0) return;
			
			$this->shop->view['arFiles'] = $arFiles;			
			
		} // public function order_view_sidebar(&$order_id)
		
		public function delOrder($order_id) 
		{ 
			 
			// Hochgeladene Dateien löschen
			$path = $this->getSavePath($order_id);
			
			wpsg_rrmdir($path);
			            
		} // public function delOrder($order_id)

        public function product_addedit_content(&$product_content, &$product_data) {
 
            if (isset($_REQUEST['wpsg_lang'])) return;

            $this->shop->view['wpsg_mod_orderupload']['set'] = $product_data['wpsg_mod_orderupload_set'];
            $this->shop->view['wpsg_mod_orderupload']['mandatory'] = $product_data['wpsg_mod_orderupload_mandatory'];
            
            $this->shop->view['arSubAction']['wpsg_mod_orderupload'] = array(
                'title' => __('Bestellupload', 'wpsg'),
                'content' => $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_orderupload/product_addedit_content.phtml', false)
            );

        } // public function produkt_edit_allgemein(&$produkt_data)
 
        public function produkt_save_before(&$produkt_data) {  
            
            if (wpsg_isSizedArray($_REQUEST['wpsg_mod_orderupload'])) {

                $produkt_data['wpsg_mod_orderupload_set'] = wpsg_sinput("key", $_REQUEST['wpsg_mod_orderupload']['set']);
                $produkt_data['wpsg_mod_orderupload_mandatory'] = wpsg_sinput("key", $_REQUEST['wpsg_mod_orderupload']['mandatory']);
                 
            }
            
        } // public function produkt_save(&$produkt_id)

        public function template_redirect() {

            if (wpsg_isSizedString($_REQUEST['action'], 'wpsg_mod_orderupload_upload')) {
                 
                if ($_REQUEST['order_id'] != $_SESSION['wpsg']['order_id']) throw new \Exception(__('Zugriffsfehler!', 'wpsg'));
                
                $path = $this->getProductStoragePath($_REQUEST['order_id'], $_REQUEST['product_index']);
                
                $oProduct = wpsg_product::getInstance($_REQUEST['product_id']);
                                
                if (!$this->shop->hasFrontendError()) {
                                        
                    // Upload
                    foreach ($_FILES['file']['tmp_name'] as $k => $f) {

                        $arFilesUploaded = $this->getProductUploads($_REQUEST['order_id'], $_REQUEST['product_index']);
                        if (sizeof($arFilesUploaded) >= $oProduct->wpsg_mod_orderupload_set) { $this->shop->addFrontendError(wpsg_translate(__('Sie haben die maximale Anzahl an Dateien (#1#) für dieses Produkt erreicht.', 'wpsg'), $oProduct->wpsg_mod_orderupload_set)); break; }

                        move_uploaded_file($f, $path.$_FILES['file']['name'][$k]);
                        
                    }
                    
                }

                echo $this->renderUploadTarget($_SESSION['wpsg']['order_id'], $_REQUEST['product_index'], $_REQUEST['product_id']); exit;
                
            } else if (wpsg_isSizedString($_REQUEST['action'], 'wpsg_mod_orderupload_delete')) {

                if ($_REQUEST['order_id'] != $_SESSION['wpsg']['order_id']) throw new \Exception(__('Zugriffsfehler!', 'wpsg'));
                
                $path = $this->getProductStoragePath($_SESSION['wpsg']['order_id'], $_REQUEST['product_index']);
                
                if (file_exists($path.basename($_REQUEST['file']))) unlink($path.basename($_REQUEST['file']));
                else $this->shop->addFrontendError(__('Datei konnte nicht gefunden werden.', 'wpsg'));
                
                echo $this->renderUploadTarget($_SESSION['wpsg']['order_id'], $_REQUEST['product_index'], $_REQUEST['product_id']); exit;
                
            }
            
        }

        /** Wird aufgerufen wenn ein Produkt aus dem Warenkorb entfernt wird */
        public function basket_removeProduktFromSession($product_index) { 
            
            $path = $this->getProductStoragePath($_SESSION['wpsg']['order_id'], $product_index);
            $arFiles = $this->getProductUploads($_SESSION['wpsg']['order_id'], $product_index);
            
            foreach ($arFiles as $f) {
                
                @unlink($f);
                
            }
            
        } // public function basket_removeProduktFromSession($product_index)
        
        public function basket_row(&$p, $i) {  
            
            if (!wpsg_isSizedInt($p['wpsg_mod_orderupload_set'])) return false;

            $this->shop->view['wpsg_mod_orderupload']['order_id'] = $_SESSION['wpsg']['order_id'];
            $this->shop->view['wpsg_mod_orderupload']['product_id'] = $p['product_id'];
            $this->shop->view['wpsg_mod_orderupload']['product_index'] = $p['product_index']; 
            $this->shop->view['wpsg_mod_orderupload']['strHTMLTarget'] = $this->renderUploadTarget($_SESSION['wpsg']['order_id'], $p['product_index'], $p['product_id']);
                         
            $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_orderupload/basket_row.phtml');
            
        } // public function basket_row_afterproducts(&$p, $i)

        public function basket_after(&$basket_view) {

            $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_orderupload/basket_after.phtml');
            
        } // public function basket_after(&$basket_view)
        
        public function order_view_row(&$p, $i) { 
            
            $order_id = $this->shop->view['data']['id'];
            $product_index = $p['product_index'];

            $arUploadedFiles = $this->getProductUploads($order_id, $product_index);

            if (wpsg_isSizedArray($arUploadedFiles)) {

                $arFileDownloadLinks = [];
                
                foreach ($arUploadedFiles as $f) {

                    $arFileDownloadLinks[] = '<a target="_blank" href="'.WPSG_URL_WP.'wp-admin/admin.php?page=wpsg-Order&action=view&product_index='.$product_index.'&edit_id='.$order_id.'&noheader=1&action=ajax&mod=wpsg_mod_orderupload&wpsg_mod_orderupload_download='.rawurlencode(basename($f)).'">'.basename($f).'</a>';
                }

                $this->shop->view['wpsg_mod_orderupload']['arFileDownloadLinks'] = $arFileDownloadLinks;
                $this->shop->view['wpsg_mod_orderupload']['arFiles'] = $arUploadedFiles;
                $this->shop->view['wpsg_mod_orderupload']['i'] = $i;
                $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_orderupload/order_view_row.phtml');
                
            } 
            
        } // public function order_view_row(&$p, $i)
        
		/* -- */
		
		private function renderUploadTarget($order_id, $product_index, $product_id) {

            $this->shop->view['wpsg_mod_orderupload']['oProduct'] = wpsg_Product::getInstance($product_id);
            $this->shop->view['wpsg_mod_orderupload']['order_id'] = $order_id;
		    $this->shop->view['wpsg_mod_orderupload']['product_index'] = $product_index;
            $this->shop->view['wpsg_mod_orderupload']['product_id'] = $product_id;
            $this->shop->view['wpsg_mod_orderupload']['arFiles'] = $this->getProductUploads($order_id, $product_index);

		    return $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_orderupload/basket_row_upload_target.phtml', false);
		     
        } // private function renderUploadTarget($order_id, $product_index)
		
		public function getNewName($filename, $order_id)
		{
			
			$arReplace = array(
				'/%filename%/' => $filename,
				'/%filename_clear%/' => preg_replace('/\.(.*)$/', '', $filename) 
			);
			
			$filename = preg_replace(array_keys($arReplace), array_values($arReplace), $this->shop->get_option('wpsg_mod_orderupload_filename'));
			
			$filename = $this->shop->replaceUniversalPlatzhalter($filename, $order_id);
			
			return $filename;
			
		} // public function getNewName($filename, $order_id)
		
		public function getSavePath($order_id, $burl = false)
 		{
 		 
 			if ($this->shop->isMultiBlog())
			{

				$url = WPSG_URL_CONTENT.WPSG_MB_UPLOADS.'/wpsg/wpsg_orderupload/'.$order_id.'/';
				$path = WP_CONTENT_DIR.'/'.WPSG_MB_UPLOADS.'/wpsg/wpsg_orderupload/'.$order_id.'/'; 
				 
			}
			else
			{
				
				$url = WPSG_URL_CONTENT.'uploads/wpsg/wpsg_orderupload/'.$order_id.'/';
				$path = WP_CONTENT_DIR.'/uploads/wpsg/wpsg_orderupload/'.$order_id.'/';
								
			}
			
			$this->shop->protectDirectory($path);
			 			
			if ($burl) return $url;
			else return $path;
			
 		} // public function getSavePath($order_id, $url = false)

        /**
         * Gibt den Pfad zurück, in dem die Dateien zu einer Bestellung/Produkt gespeichert sind
         */
        public function getProductStoragePath($order_id, $product_index) {

            $path = $this->shop->getUplodatStoragePath().'wpsg_orderupload/'.$order_id.'/'.$product_index.'/';
             
            if (!file_exists($path)) mkdir($path, 0755, true);
            
            return $path;
            
        } // public function getProductStorage($order_id, $product_index)
        
        public function getProductUploads($order_id, $product_index) {
            
            $arFiles = [];
            
            $path = $this->getProductStoragePath($order_id, $product_index);

            foreach (scandir($path) as $file) {
                
                if (!in_array($file, ['.', '..']) && is_file($path.$file)) $arFiles[] = $path.$file;
                
            }
            
            asort($arFiles);
            
            return $arFiles;
            
        } // public function getProductUploads($order_id, $product_index)
        
 		public function getAdminAttachment(&$attach)
 		{
 			
 			$o_id = $_SESSION['wpsg']['order_id'];
 			$path = $this->getSavePath($o_id);
 			
 			if ($this->shop->get_option('wpsg_mod_orderupload_mail') == 1) {
 				
	 			foreach ($_SESSION['wpsg']['wpsg_mod_orderupload'] as $k => $ou)
	 			{
	 			    	 				
	 				$attach[] = $path.$this->getNewName($ou[0], $o_id);
	 				
	 				unset($_SESSION['wpsg']['wpsg_mod_orderupload'][$k]);
	 				
	 			}
	 			
	 			$order_id = $this->shop->view['o_id'];
                
                foreach ($this->shop->view['basket']['produkte'] as $product_basket_data) {
 
                    $arFilesUploaded = $this->getProductUploads($order_id, $product_basket_data['product_index'], $product_basket_data['product_id']);
                    
                    if (wpsg_isSizedArray($arFilesUploaded)) {

                        foreach ($arFilesUploaded as $file) {
                            
                            $attach[] = $file;
                            
                        }

                    }
                    
                } 
                
 				if ($this->shop->get_option('wpsg_mod_orderupload_zip') == 1) {
 					
 					$zpath = $path.$this->getNewName('archiv', $o_id).'.zip';
 					
                    // Objekt erstellen und prüfen, ob der Server zippen kann
 					$zip = new ZipArchive();
 					
                    // ZIPARCHIVE::CREATE | ZIPARCHIVE::OVERWRITE überschreibt nicht das Archiv,
 					// deshalb die Archivdatei vorher löschen
 					if (file_exists($zpath)) unlink($zpath);
 					
 					if ($zip->open($zpath, ZIPARCHIVE::CREATE | ZIPARCHIVE::OVERWRITE) !== TRUE) { throw new \Exception("Could not open archive"); }
 					
 					foreach ($attach as $k => $v) {
 						
 						$vl = pathinfo($v);
 						$zip->addFile($v, $vl['basename']);
                        
 					}

 					// Zip-Datei speichern
 					$zip->close();
 					
 					$attach = array();
 					$attach[] = $zpath;
 					
 				}
 				
 			}
 			
 		} // public function getAdminAttachment(&$attach)
 		
	} // class wpsg_mod_orderupload extends wpsg_mod_basic
